<script setup>
import { ref, computed, onUnmounted } from "vue";
import QuestionComponent from "./QuestionComponent.vue";
const errorMessage = ref("");
const questions = [
  {
    question: "What is the capital of France?",
    options: ["London", "Berlin", "Paris", "Rome"],
    answer: "Paris",
  },
  {
    question: "Which planet is closest to the sun?",
    options: ["Earth", "Mars", "Venus", "Mercury"],
    answer: "Mercury",
  },
  {
    question: "Who invented the phone?",
    options: ["Edisson", "Einstein", "Jobs", "Bell"],
    answer: "Bell",
  },
];
const id = ref(0);
const q = computed(() => questions[id.value]);
const grade = ref(0);
const correct = ref("");
const isLastQuestion = computed(() => id.value + 1 >= questions.length);
const finished = ref(false);
const next = (ok) => {
  correct.value = ok;
  if (ok) {
    grade.value += 1;
    errorMessage.value = "That's correct.";
  } else {
    errorMessage.value = "Sorry, that's not the right answer.";
  }
  if (isLastQuestion.value) {
    finished.value = true;
  } else {
    id.value += 1;
  }
};
const interval = setInterval(() => {
  errorMessage.value = "";
}, 3000);
onUnmounted(() => clearInterval(interval));
</script>
<template>
  <div class="quiz">
    <div
      class="quiz__message"
      v-if="errorMessage"
      :class="correct ? 'quiz__message--correct' : 'quiz__message--incorrect'"
    >
      {{ errorMessage }}
    </div>
    <question-component
      :q="q"
      :finished="finished"
      @next="next"
    ></question-component>
    <div class="quiz__footer">
      <router-link
        v-if="finished"
        type="button"
        :to="{
          name: 'results',
          params: { g: Math.round((100 * grade) / questions.length) },
        }"
        class="quiz__cta"
        >Submit</router-link
      >
    </div>
  </div>
</template>

<style scoped>
.quiz {
  min-width: 500px;
  max-width: 700px;
  display: flex;
  flex-direction: column;
  background-color: #3d3d3d;
  border-radius: 12px;
  padding: 2em;
}
.quiz__message {
  @apply text-white font-bold rounded-t px-4 py-2;
  float: right;
  margin-bottom: 15px;
}
.quiz__message--correct {
  @apply bg-green-500;
}
.quiz__message--incorrect {
  @apply bg-red-500;
}
.quiz__footer {
  text-align: right;
}
.quiz__cta {
  @apply bg-blue-500 hover:bg-blue-700 text-white font-bold py-2 px-8 border border-blue-700 rounded;
}
</style>
